<?php
namespace gallery\system\event\listener;
use wcf\system\event\IEventListener;
use wcf\data\user\jcoins\statement\UserJcoinsStatementAction;

/**
 * Listen to Image action for jCoins
 * 
 * @author		Mirco Sarkissian
 * @copyright	2014 Mirco Sarkissian
 * @license		Creative Commons BY-SA <http://creativecommons.org/licenses/by-sa/4.0/>
 * @package		com.ms.gallery.jcoins
 * @subpackage	system.event.listener
 * @category	Community Gallery
 */
class JCoinsMsImageCreateListener implements IEventListener {
	/**
	 * @see	wcf\system\event\IEventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		
		// need module
		if (!MODULE_JCOINS) return;
		
		// need action 'saveImageData'
		$action = $eventObj->getActionName();
		if ($action == 'saveImageData') {
			
			$sum = JCOINS_RECEIVECOINS_MSIMAGE_CREATE;
			$objects = $eventObj->getObjects();
			foreach ($objects as $object) {
				$userID = $object->userID;
				
				if ($userID && $sum != 0) {
					$action = new UserJcoinsStatementAction(array(), 'create', array(
						'data' => array(
								'reason' => 'wcf.jcoins.statement.imageadd.receive',
								'sum' => $sum,
								'userID' => $userID
						),
						'changeBalance' => 1
					));
					$action->validateAction();
					$action->executeAction();
				}
			}
		}
	}
}
